import { Key, Selector } from "../ServiceCollection";
import { ILifetime } from "../Lifetime";
import { IServiceProvider } from "./IServiceProvider";
export interface IDependencyTracker {
    readonly last: ILifetime<any, any> | undefined;
    readonly depth: number;
    readonly singleton?: ILifetime<any, any>;
    enter(lifetime: ILifetime<any, any>): void;
    leave(lifetime: ILifetime<any, any>): void;
    traverseOnto(other: IDependencyTracker): void;
    clone(): IDependencyTracker;
}
export declare class DependencyTracker implements IDependencyTracker {
    private readonly singletons;
    private readonly lookup;
    private readonly ordered;
    get depth(): number;
    get singleton(): ILifetime<any, any> | undefined;
    get last(): ILifetime<any, any> | undefined;
    enter(lifetime: ILifetime<any, any>): void;
    leave(lifetime: ILifetime<any, any>): void;
    traverseOnto(other: IDependencyTracker): void;
    clone(): DependencyTracker;
}
export declare type ProviderScope = Record<Key<any>, any>;
export declare class ScopedContext<E> implements IServiceProvider<E> {
    readonly dependencyTracker: IDependencyTracker;
    readonly lifetimes: Record<Key<E>, ILifetime<any, E>>;
    readonly proxy: E;
    readonly scope: ProviderScope;
    private parent;
    constructor(parent: IServiceProvider<E>);
    provide<T>(selector: Selector<T, E>): T;
    clone(): ScopedContext<E>;
}
